## ros-eloquent-system-modes 0.4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(system_modes)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(builtin_interfaces REQUIRED)
find_package(std_msgs REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(rosidl_typesupport_cpp REQUIRED)
find_package(rosidl_default_generators REQUIRED)
find_package(lifecycle_msgs REQUIRED)

# generate service
rosidl_generate_interfaces(${PROJECT_NAME}
  "msg/Mode.msg"
  "msg/ModeEvent.msg"
  "srv/ChangeMode.srv"
  "srv/GetMode.srv"
  "srv/GetAvailableModes.srv"
  ADD_LINTER_TESTS
  DEPENDENCIES builtin_interfaces
)

add_library(mode SHARED
  src/system_modes/mode.cpp
  src/system_modes/mode_impl.cpp
  src/system_modes/mode_handling.cpp
  src/system_modes/mode_inference.cpp)
target_include_directories(mode PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(mode
  "rclcpp"
  "rcl_lifecycle"
  "rclcpp_lifecycle"
  "lifecycle_msgs"
  "rosidl_typesupport_cpp"
  "std_msgs"
  "builtin_interfaces"
)
#rosidl_target_interfaces(mode
# ${PROJECT_NAME} "rosidl_typesupport_cpp")
# TODO Should work with the two lines above, but doesn't
include_directories(../../build/system_modes/rosidl_generator_cpp/)
link_directories(../../build/system_modes/)
target_link_libraries(mode system_modes__rosidl_typesupport_cpp)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(mode PRIVATE "SYSTEMMODES_BUILDING_LIBRARY")

install(
  DIRECTORY include/
  DESTINATION include
)
install(
  TARGETS mode
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# mode manager
add_executable(mode_manager src/system_modes/mode_manager.cpp
                            src/mode_manager_node.cpp)
target_include_directories(mode_manager PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(mode_manager mode)
install(TARGETS mode_manager
  DESTINATION lib/${PROJECT_NAME})

# mode monitor
add_executable(mode_monitor src/system_modes/mode_monitor.cpp
                            src/mode_monitor_node.cpp)
target_include_directories(mode_monitor PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(mode_monitor mode)
install(TARGETS mode_monitor
  DESTINATION lib/${PROJECT_NAME})

  # launch
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME}/)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_gmock REQUIRED)
  # the following line skips the linter which checks for copyrights
  # remove the line when a copyright and license is present in all source files
  set(ament_cmake_copyright_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()

  set(MODE_FILE_CORRECT ${CMAKE_CURRENT_SOURCE_DIR}/test/test_modes.yaml)
  set(MODE_FILE_WRONG ${CMAKE_CURRENT_SOURCE_DIR}/test/test_modes_wrong.yaml)
  configure_file(test/modefiles.h.in ${CMAKE_CURRENT_BINARY_DIR}/system_modes/modefiles.h)
  include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

  ament_add_gtest(test_state_and_mode_struct test/test_state_and_mode_struct.cpp)
  if(TARGET test_state_and_mode_struct)
    target_include_directories(test_state_and_mode_struct PUBLIC
      ${rclcpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_state_and_mode_struct mode)
  endif()

  ament_add_gtest(test_default_mode test/test_default_mode.cpp)
  if(TARGET test_default_mode)
    target_include_directories(test_default_mode PUBLIC
      ${rclcpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_default_mode mode)
  endif()

  ament_add_gtest(test_mode test/test_mode.cpp)
  if(TARGET test_mode)
    target_include_directories(test_mode PUBLIC
      ${rclcpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_mode mode)
  endif()

  ament_add_gtest(test_mode_inference test/test_mode_inference.cpp)
  if(TARGET test_mode_inference)
    target_include_directories(test_mode_inference PUBLIC
      ${rclcpp_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/system_modes/
    )
    target_link_libraries(test_mode_inference mode)
  endif()
endif()

ament_export_include_directories(include)
#ament_export_interfaces(export_${PROJECT_NAME})
ament_export_libraries(mode)
ament_export_libraries(${PROJECT_NAME}__rosidl_typesupport_introspection_cpp)
ament_export_dependencies(rclcpp)
ament_export_dependencies(rclcpp_lifecycle)
ament_export_dependencies(lifecycle_msgs)
ament_export_dependencies(std_msgs)
ament_package()

=== debian/changelog ===
ros-eloquent-system-modes (0.4.2-2bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Arne Nordmann <arne.nordmann@bosch.com>  Thu, 17 Dec 2020 10:06:30 -0000

=== debian/control ===
Source: ros-eloquent-system-modes
Section: misc
Priority: optional
Maintainer: Arne Nordmann <arne.nordmann@bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-ament-cmake, ros-eloquent-ament-cmake-cppcheck, ros-eloquent-ament-cmake-cpplint, ros-eloquent-ament-cmake-flake8, ros-eloquent-ament-cmake-gmock, ros-eloquent-ament-cmake-gtest, ros-eloquent-ament-cmake-pep257, ros-eloquent-ament-cmake-uncrustify, ros-eloquent-ament-lint-auto, ros-eloquent-builtin-interfaces, ros-eloquent-rclcpp, ros-eloquent-rclcpp-lifecycle, ros-eloquent-rosidl-default-generators, ros-eloquent-std-msgs, ros-eloquent-ros-workspace, ros-eloquent-rosidl-typesupport-connext-c, ros-eloquent-rosidl-typesupport-connext-cpp, ros-eloquent-rosidl-typesupport-fastrtps-c, ros-eloquent-rosidl-typesupport-fastrtps-cpp, ros-eloquent-rmw-connext-cpp, ros-eloquent-rmw-fastrtps-cpp, ros-eloquent-rmw-implementation, ros-eloquent-rmw-opensplice-cpp, ros-eloquent-rosidl-typesupport-opensplice-c, ros-eloquent-rosidl-typesupport-opensplice-cpp
Homepage: 
Standards-Version: 3.9.2

Package: ros-eloquent-system-modes
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-builtin-interfaces, ros-eloquent-launch-ros, ros-eloquent-rclcpp, ros-eloquent-rclcpp-lifecycle, ros-eloquent-rosidl-default-generators, ros-eloquent-std-msgs, ros-eloquent-ros-workspace
Description: The system modes concept assumes that a robotics system is built from components with a lifecycle.
 It adds a notion of (sub-)systems, hiararchically grouping these nodes, as well as a notion of modes that determine the configuration of these nodes and (sub-)systems in terms of their parameter values.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-system-modes//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
